﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Microsoft.Research.Kinect.Nui;
using Microsoft.Research.Kinect.Audio;

namespace HelloKinectWorldWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Runtime nui = Runtime.Kinects[0] ;
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            nui.Initialize(RuntimeOptions.UseColor);
            nui.VideoStream.Open(
                  ImageStreamType.Video,
                  2,
                  ImageResolution.Resolution640x480,
                  ImageType.Color);
            nui.VideoFrameReady += new EventHandler<ImageFrameReadyEventArgs>(FrameReady);
        }
        void FrameReady(object sender, ImageFrameReadyEventArgs e)
        {
            PlanarImage Image = e.ImageFrame.Image;
            BitmapSource bmap = PImageToBitmapSource(Image);
            image1.Source = bmap;
        }

        BitmapSource PImageToBitmapSource(PlanarImage PImage)
        {
             BitmapSource bmap = BitmapSource.Create(
             PImage.Width,
             PImage.Height,
             96, 96,
             PixelFormats.Bgr32,
             null,
             PImage.Bits,
             PImage.Width * PImage.BytesPerPixel);
             return bmap;
        }
    }
}